'use strict';

module.exports = exports = function AppExporter() {
  var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
  var context = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  var project = context.project;
  var app = options.app;

  var settingsBase = undefined;

  if (project.getSetting('apps')) {
    if (!app && !project.getSetting('app.current')) {
      throw 'Multiple app settings exist. Missing app parameter. Specify which app you want to export either as settings.app.current are as an argument.';
    }

    app = app || project.getSetting('app.current');

    settingsBase = project.get('settings.apps.' + app);
  } else if (project.getSetting('app')) {
    settingsBase = project.getSetting('app');
  } else {
    settingsBase = project.settings;
  }

  var copyBase = project.get('copy.' + app, project.get('copy', {}));

  var base = {
    copy: copyBase,
    settings: settingsBase
  };

  if (options.includeBuildSettings) {
    if (project.getSetting('builds.' + app)) {
      base.buildOptions = project.getSetting('builds.' + app);
    }
  }

  if (options.includeEntities) {
    base.entities = project.exporters.run('entities', options);
  }

  return base;
};