module.exports = exports = function AppExporter (options = {}, context = {}) {
  const { project } = context
  let { app } = options

  let settingsBase

  if (project.getSetting('apps')) {
    if (!app && !project.getSetting('app.current')) {
      throw('Multiple app settings exist. Missing app parameter. Specify which app you want to export either as settings.app.current are as an argument.')
    }

    app = app || project.getSetting('app.current')

    settingsBase = project.get('settings.apps.' + app)

  } else if (project.getSetting('app')) {
    settingsBase = project.getSetting('app')
  } else {
     settingsBase = project.settings
  }

  let copyBase = project.get('copy.' + app, project.get('copy', {}))

  let base = {
    copy: copyBase,
    settings: settingsBase
  }

  if (options.includeBuildSettings) {
    if (project.getSetting(`builds.${ app }`)) {
      base.buildOptions = project.getSetting(`builds.${ app }`)
    }
  }

  if (options.includeEntities) {
    base.entities = project.exporters.run('entities', options)
  }

  return base
}
