function CollectionBundle(options = {}){
  let project = options.project || this

  const pick = require('../util').pick
  const lodashify = require('../util').lodashify(
    'pick', 'pickBy', 'omit', 'omitBy', 'get', 'set', 'keys', 'values'
  )

  const allAssets = project.allAssets.map(a => a.readSync())

  const bundle = allAssets.reduce(
    (memo, asset) => {
      asset.indexed

      let assetData = pick(
        asset,
        'id', 'uri', 'fingerprint', 'paths', 'raw', 'parsed', 'indexes'
      )

      memo[asset.paths.projectRequire] = lodashify(assetData)

      return memo
    }, {__project_root: project.root}
  )

  return lodashify(bundle)
}

module.exports = CollectionBundle
