import vm from 'vm'
import { compiler } from './assets/parsers/babel'

export class VirtualMachine {
  constructor(params = {}, context = {}) {
    const { project, asset } = context

    Object.defineProperty(this, 'sandbox', {
      enumerable: false,
      configurable: false,
      value: {
        project,
        asset,
        _: require('lodash'),
        polyfill: function() { try { require('babel-polyfill') } catch(error) {  } },
        console
      }
    })

    Object.defineProperty(this, 'context', {
      enumerable: false,
      configurable: false,
      value: vm.createContext(this.sandbox)
    })
  }

  run(es6, transformerOptions = {}) {
    let code = compiler(es6, {id: this.context.project.registryId, transformerOptions})
    return vm.runInContext(`polyfill(); ${ code }`, this.context)
  }
}

export default VirtualMachine
